<?php

namespace goodboyalex\php_components_pack\enums;

use goodboyalex\php_components_pack\traits\EnumExtensionsTrait;

/**
 * Перечисление типов получения хэша.
 *
 * @author Александр Бабаев
 * @package php_components_pack
 * @version 1.1
 * @since 1.0.5
 */
enum HashGetType: int
{
    // Подключаю расширение для Enum
    use EnumExtensionsTrait;

    /**
     * По строке хэша.
     */
    case ByHash = 0;

    /**
     * По строке.
     */
    case ByString = 1;

    /**
     * По файлу.
     */
    case ByFile = 2;
}