<?php

namespace goodboyalex\php_components_pack\enums;

use goodboyalex\php_components_pack\traits\EnumExtensionsTrait;

/**
 * Перечисление стадий в информации о версии.
 *
 * @author Александр Бабаев
 * @package php_components_pack
 * @version 1.0
 * @since 1.0.24
 */
enum VersionInfoStage: int
{
    // Подключаю расширение для Enum
    use EnumExtensionsTrait;

    /**
     * Не определена или не задана стадия.
     */
    case Undefined = 0;

    /**
     * Пре-алфа.
     */
    case PreAlpha = 1;

    /**
     * Альфа.
     */
    case Alpha = 2;

    /**
     * Бета.
     */
    case Beta = 3;

    /**
     * Кандидат в релиз.
     */
    case ReleaseCandidate = 4;

    /**
     * Релиз.
     */
    case Stable = 5;
}